gtkmm: Gtk::UriLauncher Class Reference

gtkmm 4.23.2

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gtk::UriLauncher Class Reference

A Gtk::UriLauncher object collects the arguments that are needed to open a uri with an application. More...

`#include <gtkmm/urilauncher.h>`

Inheritance diagram for Gtk::UriLauncher:
[legend]

## Public Member Functions
| UriLauncher (UriLauncher && src) noexcept
UriLauncher & | operator= (UriLauncher && src) noexcept
| ~UriLauncher () noexcept override
GtkUriLauncher * | gobj ()
| Provides access to the underlying C GObject.
const GtkUriLauncher * | gobj () const
| Provides access to the underlying C GObject.
GtkUriLauncher * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
Glib::ustring | get_uri () const
| Gets the uri that will be opened.
void | set_uri (const Glib::ustring & uri)
| Sets the uri that will be opened.
void | launch (Window & parent, const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| Launches an application to open the uri.
void | launch (const Gio::SlotAsyncReady & slot, const Glib::RefPtr< Gio::Cancellable > & cancellable={}) const
| A launch() convenience overload.
bool | launch_finish (const Glib::RefPtr< Gio::AsyncResult > & result) const
| Finishes the launch() call and returns the result.
bool | can_launch (const Window & parent) const
| Returns whether the launcher is likely to succeed in launching an application for its uri.
bool | can_launch () const
| A can_launch() convenience overload.
Glib::PropertyProxy< Glib::ustring > | property_uri ()
| The uri to launch.
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_uri () const
| The uri to launch.
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data_with_c_callback (const Quark &key, void *data, GDestroyNotify notify)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src) noexcept
| ~trackable ()
void | add_destroy_notify_callback (notifiable *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src) noexcept
void | remove_destroy_notify_callback (notifiable *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system.
static Glib::RefPtr< UriLauncher > | create (const Glib::ustring & uri={})
| Creates a new Gtk::UriLauncher object.

## Protected Member Functions
| UriLauncher (const Glib::ustring & uri)
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gtk::UriLauncher > | wrap (GtkUriLauncher * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Public Types inherited from sigc::notifiable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A Gtk::UriLauncher object collects the arguments that are needed to open a uri with an application.

Depending on system configuration, user preferences and available APIs, this may or may not show an app chooser dialog or launch the default application right away.

The operation is started with the launch() method. This API follows the GIO async pattern, and the result can be obtained by calling launch_finish().

To launch a file, use Gtk::FileLauncher.

Since gtkmm 4.10

## Constructor & Destructor Documentation

## ◆ UriLauncher() [1/2]

Gtk::UriLauncher::UriLauncher | ( | UriLauncher && | src | ) |
| noexcept

## ◆ ~UriLauncher()

Gtk::UriLauncher::~UriLauncher | ( |  | ) |
| overridenoexcept

## ◆ UriLauncher() [2/2]

Gtk::UriLauncher::UriLauncher | ( | const Glib::ustring & | uri | ) |
| explicitprotected

## Member Function Documentation

## ◆ can_launch() [1/2]

bool Gtk::UriLauncher::can_launch | ( |  | ) | const

A can_launch() convenience overload.

## ◆ can_launch() [2/2]

bool Gtk::UriLauncher::can_launch | ( | const Window & | parent | ) | const

Returns whether the launcher is likely to succeed in launching an application for its uri.

This can be used to disable controls that trigger the launcher when they are known not to work.

Since gtkmm 4.20

Parameters

  parent | The parent window.

Returns
  False if the launcher is known not to support the uri, true otherwise.

## ◆ create()

Glib::RefPtr< UriLauncher > Gtk::UriLauncher::create | ( | const Glib::ustring & | uri = {} | ) |
| static

Creates a new Gtk::UriLauncher object.

Since gtkmm 4.10

Parameters

  uri | The uri to open, or an empty string to specify the uri later with set_uri().

Returns
  The new Gtk::UriLauncher.

## ◆ get_type()

GType Gtk::UriLauncher::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ get_uri()

Glib::ustring Gtk::UriLauncher::get_uri | ( |  | ) | const

Gets the uri that will be opened.

Since gtkmm 4.10

Returns
  The uri.

## ◆ gobj() [1/2]

GtkUriLauncher * Gtk::UriLauncher::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkUriLauncher * Gtk::UriLauncher::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkUriLauncher * Gtk::UriLauncher::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ launch() [1/2]

void Gtk::UriLauncher::launch | ( | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = {} ) const

A launch() convenience overload.

## ◆ launch() [2/2]

void Gtk::UriLauncher::launch | ( | Window & | parent,
|  | const Gio::SlotAsyncReady & | slot,
|  | const Glib::RefPtr< Gio::Cancellable > & | cancellable = {} ) const

Launches an application to open the uri.

This may present an app chooser dialog to the user.

Since gtkmm 4.10

Parameters

  parent | The parent window.
  cancellable | A cancellable to cancel the operation.
  slot | A callback to call when the operation is complete.

## ◆ launch_finish()

bool Gtk::UriLauncher::launch_finish | ( | const Glib::RefPtr< Gio::AsyncResult > & | result | ) | const

Finishes the launch() call and returns the result.

Since gtkmm 4.10

Parameters

  result | The result.

Returns
  True if an application was launched.

Exceptions

  Gtk::DialogError |
  Gio::Error |

## ◆ operator=()

UriLauncher & Gtk::UriLauncher::operator= | ( | UriLauncher && | src | ) |
| noexcept

## ◆ property_uri() [1/2]

Glib::PropertyProxy< Glib::ustring > Gtk::UriLauncher::property_uri | ( |  | ) |

The uri to launch.

Since gtkmm 4.10

Default value: ""

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_uri() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::ustring > Gtk::UriLauncher::property_uri | ( |  | ) | const

The uri to launch.

Since gtkmm 4.10

Default value: ""

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_uri()

void Gtk::UriLauncher::set_uri | ( | const Glib::ustring & | uri | ) |

Sets the uri that will be opened.

Since gtkmm 4.10

Parameters

  uri | The uri.

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::UriLauncher > wrap | ( | GtkUriLauncher * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.